﻿# fuelle-iterativ-HGT.py
# Programm zum Füllen eines Containers
# mit vollständigem Suchverfahren, bei dem
# alle Alternativen generiert werden und
# gleich getestet werden.
# Dies ist also "Hierarchical Generate and Test" HGT

# Globale Variable für die Stücke:
stuecke=[30,30,30,20,20,20,20]

# Prädikat zum Testen, ob der Container voll ist.
def istVoll(container, fassungsvermoegen):
    return fassungsvermoegen==sum(container)

def istZuVoll(container, fassungsvermoegen):
    return fassungsvermoegen<sum(container)

def fuelle(stuecke, fassungsvermoegen):
    alternativen=[]
    # Alternativen sind: rein oder nicht rein
    for stueck in stuecke:
        ##print(alternativen,'\n')
        if alternativen==[]:
            alternativen=[[stuecke[0]],[]]
        else:
            temp=[]
            for alt in alternativen:
                if istVoll(alt+[stueck], fassungsvermoegen):
                    print('voll')
                    return alt+[stueck]
                if istZuVoll(alt+[stueck], fassungsvermoegen):
                    temp+=[alt]
                else:
                    temp+=[alt+[stueck],alt]
            alternativen=temp
    print('erfolglos')
    return []

### Tests
def ausgabe(stuecke, fassungsvermoegen):
    print('Stücke:', stuecke, fassungsvermoegen,
          'Ergebnis:\n', fuelle(stuecke, fassungsvermoegen), '\n')

ausgabe( [30,20], 50)
ausgabe( stuecke, 80)
ausgabe( stuecke, 90)
ausgabe( stuecke, 170)
ausgabe( stuecke, 100)
ausgabe( stuecke*2, 200)
ausgabe( stuecke*3, 510)
ausgabe( stuecke*3, 1000)
